class Flattener_112:UIFrame112
{
number MarkerSize
number imID, ROI_ID, ListID

image backup
number Middle

string SizeName

TagGroup CreateAll(object self)
	{
	TagGroup dialog = DLGCreateDialog("Dialog").DLGTableLayout(2,3,0);

	Dialog.DLGAddElement(DLGCreatePushButton("assign", "assign"))	
	Dialog.DLGAddElement(DLGCreateLabel("   ",4).DLGIdentifier("assigned"))
	Dialog.DLGAddElement(DLGCreatePushButton("fix", "fix").DLGIdentifier("fix"))
	Dialog.DLGAddElement(DLGCreatePushButton("restore", "restore").DLGIdentifier("restore"))
	
	return Dialog
	}

object init(object self,string Package,string Name,string LabelP)
	{
	//name to store parameters
	sizeName ="markerSize"	//the marker size will be stored under that name in global tags

	//initialize extended frame
	self.initUIFrame112(self.CreateAll(),Package,Name)	//initialise temDM extended frames

	markerSize =self.LoadNumber112(2,sizeName)	//load the marker size from global tags. If doesnot exist, takes default value 2
	
	self.SetElementIsEnabled("fix",0)
	self.SetElementIsEnabled("restore",0)
	
	return self
	}

	
void CloseUIFrame112(object self)
	{
	//add some actions if neccesary
	}
	
number AboutToCloseUIFrame112( object self, number verify )
	{
	self.StoreNumber112(markerSize,sizeName)	//store the marker size in global tags
	
	try{										//delete marker
		ROI marker =GetROIFromID(ROI_ID)
		imageDisplay disp =imID.getImageFromID().ImageGetImageDisplay(0)
		disp.ImageDisplayRemoveEventListener(ListID)
		disp.ImageDisplayDeleteROI(marker)
		}
	catch break	
	}		


void ParkMarker(object self,ROI marker, image treated)	//set marker to the middle of the image
	{
	number width,height
	treated.getSize(width,height)
	
	number size =2
	number left =width/2*(1-size/100)
	number right =width/2*(1+size/100)
	number top =height/2*(1-size/100)
	number bottom =height/2*(1+size/100)
	
	//marker.ROISetRectangle(top,left,bottom,right)	//uncomment that for GMS1 
	marker.ROISetOval(top,left,bottom,right)		//uncomment that for GMS2,3 
	}
	
number CreateMarker(object self,image treated)	//moving this marker you can tune intensity gradient in the image
	{	
	ImageDisplay Disp = treated.ImageGetImageDisplay(0)
	
	ROI marker =NewROI()
	
	self.ParkMarker(marker,treated)

	number green =0		//change this if you want other marker color
	number blue =1
	number red =0
	
	marker.ROISetColor(red,green,blue)

	number opacity = 0	//change it if you want partually transparent marker
	marker.ROISetDrawFilled(1)							//uncomment that for GMS2,3
	marker.ROISetFillProperties(opacity,red,green,blue)	//uncomment that for GMS2,3
	
	marker.ROISetVolatile(0)
	marker.ROISetResizable(0)	
	
	Disp.ImageDisplayAddROI(marker)	
	
	string messageMap ="roi_end_track:MarkerMoved"
	ListID = Disp.ImageDisplayAddEventListener(self,messageMap)
	
	return marker.ROIGetID()
	}
	

void MarkerMoved(object self,number disp_flags, imageDisplay disp, number roi_flags1, number roi_flags2, ROI Marker) //reacts on marker move
	{
	number top,left,bottom,right
	//Marker.ROIGetRectangle(top,left,bottom,right)	//uncomment that for GMS1
	Marker.ROIGetOval(top,left,bottom,right)		//uncomment that for GMS2,3
//result("\n"+top+" "+left+" "+bottom+" "+right)	

	image treated :=disp.ImageDisplayGetImage()
	number width,height
	treated.getSize(width,height)
	
	number delX =((left +right)/2 -width/2)/width*2		//control the strength of gradient
	number delY =((top +bottom)/2 -height/2)/height*2
//result(" "+delX+" "+delY)	
	
	//bi-linear tune of intensity gradient
	//you may change it into the custom non-linear one
	treated =backup+Middle*(icol-width/2)/width*2*delX +Middle*(irow-height/2)/height*2*delY
	}
	
	
void Assign(object self)		//assign image to tune intensity gradient
	{
	if(imID!=0) if(!OKcancelDialog("treated image is already assigned\nDo you want to assign another one ?")) exit(0)
	
	image treated :=getFrontImage()
	imID =treated.ImageGetID()

	backup =treated			//keep initial image in memory
	Middle =mean(backup)	//neded for scaling the intensity gradient 

	self.LookUpElement("assigned").DLGTitle(""+treated.ImageGetLabel())
	
	self.SetElementIsEnabled("fix",1)
	self.SetElementIsEnabled("restore",1)
	
	ROI_ID =self.CreateMarker(treated)
	}


void Fix(object self)		//fix the current intensity gradient
	{	
	ROI marker =GetROIFromID(ROI_ID)
	imageDisplay disp =imID.getImageFromID().ImageGetImageDisplay(0)
	disp.ImageDisplayRemoveEventListener(ListID)
	disp.ImageDisplayDeleteROI(marker)
	
	self.SetElementIsEnabled("fix",0)
	}


void Restore(object self)	//restore the initial image
	{
	image treated :=imID.getImageFromID()
	
	try{
		//park marker in the middle
		ROI marker =GetROIFromID(ROI_ID)
		self.ParkMarker(marker,treated)	
		}
	catch 
		{
		//deassign image
		self.LookUpElement("assigned").DLGTitle("   ")	
		imID =0	
		self.SetElementIsEnabled("restore",0)
		break
		}	
		
	treated =backup
result("\nrestored")
	}
}


{
//check if ExtendedFrames are loaded
if(!doesFunctionExist("LoadNumber112")) 
	{
	OKdialog("Please drop 'temDM extFrames.gt3' plugin in the plugins folder !!");
	exit(0);
	}	
	
alloc(Flattener_112).init("_temDM-Scripts:Flattener","Flattener","Flattener") 
}